%global major 1
%global minor 03
%global commit c1cf4307c75abed8e3ecccdd23a35f7782feaf69
%global shortcommit %(c=%{commit}; echo ${c:0:7})
%global snapshotyear %(date +\%Y)
%global snapshotday %(date +\%m\%d)
%global snapshotdate %{snapshotyear}%{snapshotday}

Name:           noise-suppression-for-voice
Version:        %{major}.%{minor}^git%{snapshotdate}.%{shortcommit}
Release:        1%{?dist}

Summary:        Noise suppression plugin based on Xiph's RNNoise
License:        GPL-3.0-only
URL:            https://github.com/werman/noise-suppression-for-voice
Source0:        https://github.com/werman/%{name}/archive/%{commit}.zip

BuildRequires:  mesa-libGL-devel
BuildRequires:  libatomic
BuildRequires:  libubsan
BuildRequires:  make
BuildRequires:  cmake
BuildRequires:  gcc-c++
BuildRequires:  ladspa
BuildRequires:  ladspa-devel
BuildRequires:  libXcursor-devel
BuildRequires:  libXrandr-devel
BuildRequires:  pkgconfig
BuildRequires:  pkgconfig(freetype2)
BuildRequires:  pkgconfig(x11)
BuildRequires:  pkgconfig(xext)
BuildRequires:  pkgconfig(xinerama)

%description
The plugin is meant to suppress a wide range of noise origins
(from original paper): computer fans, office, crowd, airplane,
car, train, construction.

From my tests mild background noise is always suppressed,
loud sounds, like clicking of mechanical keyboard, are
suppressed while there is no voice however they are only
reduced in volume when voice is present.

The plugin is made to work with 1 channel and/or 2 channels
(ladspa plugin), 16 bit, 48000 Hz audio input.
Other sample rates may work, or not...

%package     -n lv2-rnnoise
Summary:        Noise suppression plugin based on Xiph's RNNoise - lv2 plugin

%description -n lv2-rnnoise
The plugin is meant to suppress a wide range of noise origins
(from original paper): computer fans, office, crowd, airplane,
car, train, construction.

From my tests mild background noise is always suppressed,
loud sounds, like clicking of mechanical keyboard, are
suppressed while there is no voice however they are only
reduced in volume when voice is present.

The plugin is made to work with 1 channel and/or 2 channels
(ladspa plugin), 16 bit, 48000 Hz audio input.
Other sample rates may work, or not...

This package holds the lv2 plugin.

%package     -n vst3-rnnoise
Summary:        Noise suppression plugin based on Xiph's RNNoise - vst3 plugin

%description -n vst3-rnnoise
The plugin is meant to suppress a wide range of noise origins
(from original paper): computer fans, office, crowd, airplane,
car, train, construction.

From my tests mild background noise is always suppressed,
loud sounds, like clicking of mechanical keyboard, are
suppressed while there is no voice however they are only
reduced in volume when voice is present.

The plugin is made to work with 1 channel and/or 2 channels
(ladspa plugin), 16 bit, 48000 Hz audio input.
Other sample rates may work, or not...

This package holds the vst3 plugin.

%package     -n vst-rnnoise
Summary:        Noise suppression plugin based on Xiph's RNNoise - vst plugin

%description -n vst-rnnoise
The plugin is meant to suppress a wide range of noise origins
(from original paper): computer fans, office, crowd, airplane,
car, train, construction.

From my tests mild background noise is always suppressed,
loud sounds, like clicking of mechanical keyboard, are
suppressed while there is no voice however they are only
reduced in volume when voice is present.

The plugin is made to work with 1 channel and/or 2 channels
(ladspa plugin), 16 bit, 48000 Hz audio input.
Other sample rates may work, or not...

This package holds the vst plugin.

%package     -n ladspa-rnnoise
Summary:        Noise suppression plugin based on Xiph's RNNoise - ladspa plugin

%description -n ladspa-rnnoise
The plugin is meant to suppress a wide range of noise origins
(from original paper): computer fans, office, crowd, airplane,
car, train, construction.

From my tests mild background noise is always suppressed,
loud sounds, like clicking of mechanical keyboard, are
suppressed while there is no voice however they are only
reduced in volume when voice is present.

The plugin is made to work with 1 channel and/or 2 channels
(ladspa plugin), 16 bit, 48000 Hz audio input.
Other sample rates may work, or not...

This package holds the ladspa plugin.

%prep
%autosetup -p1 -n %{name}-%{commit}

# use the system version of ladspa.h
%{__rm} ./src/ladspa_plugin/ladspa.h
ln -s /usr/include/ladspa.h ./src/ladspa_plugin/ladspa.h

sed -i -e 's/lxvst/vst/' src/juce_plugin/CMakeLists.txt

%build
%cmake -DBUILD_FOR_RELEASE=ON
%cmake_build

%install
%cmake_install

%files -n ladspa-rnnoise
%license LICENSE
%doc README.md
%{_libdir}/ladspa/*

%files -n lv2-rnnoise
%license LICENSE
%doc README.md
%{_libdir}/lv2/*

%files -n vst3-rnnoise
%license LICENSE
%doc README.md
%{_libdir}/vst3/*

%files -n vst-rnnoise
%license LICENSE
%doc README.md
%{_libdir}/vst/*

%changelog
* Wed Aug 24 2023 Andreas G <uriesk@posteo.de> - gitc1cf4307c75abed8e3ecccdd23a35f7782feaf69
- Updated to latest snapshot.

